/*************************************************/
/**                 system USER !!!              */
/*************************************************/

DROP TABLESPACE TBS_GRIESMAYER_INDEX INCLUDING CONTENTS AND DATAFILES;
DROP USER GRIESMAYER CASCADE;

CREATE SMALLFILE TABLESPACE TBS_GRIESMAYER_INDEX
DATAFILE '/opt/oracle/oradata/XE/XEPDB1/griesmayer_index1.dbf' SIZE 200M AUTOEXTEND ON NEXT 1M MAXSIZE UNLIMITED,
'/opt/oracle/oradata/XE/XEPDB1/griesmayer_index2.dbf' SIZE 200M
LOGGING EXTENT MANAGEMENT LOCAL SEGMENT SPACE MANAGEMENT AUTO;

CREATE USER GRIESMAYER PROFILE "DEFAULT" IDENTIFIED BY "oracle"
DEFAULT TABLESPACE TBS_GRIESMAYER_INDEX
TEMPORARY TABLESPACE TEMP
ACCOUNT UNLOCK;

GRANT SELECT ANY DICTIONARY TO GRIESMAYER;
GRANT UNLIMITED TABLESPACE TO GRIESMAYER;
GRANT CONNECT TO GRIESMAYER;
GRANT RESOURCE TO GRIESMAYER;
GRANT ALTER SYSTEM TO GRIESMAYER;



/*************************************************/
/**                 griesmayer USER !!!          */
/*************************************************/

DROP TABLE FIRSTNAME;

CREATE TABLE FIRSTNAME
(
   FIRST_NAME_ID INTEGER NOT NULL PRIMARY KEY,
   FIRST_NAME    CHAR(20),
   GENDER        CHAR(1)
);

INSERT INTO FIRSTNAME VALUES (1 ,  'Anna', 'f');
INSERT INTO FIRSTNAME VALUES (2 ,  'Hannah', 'f');
INSERT INTO FIRSTNAME VALUES (3 ,  'Lena', 'f');
INSERT INTO FIRSTNAME VALUES (4 ,  'Sarah', 'f');
INSERT INTO FIRSTNAME VALUES (5 ,  'Sophie', 'f');
INSERT INTO FIRSTNAME VALUES (6 ,  'Emma', 'f');
INSERT INTO FIRSTNAME VALUES (7 ,  'Julia', 'f');
INSERT INTO FIRSTNAME VALUES (8 ,  'Marie', 'f');
INSERT INTO FIRSTNAME VALUES (9 ,  'Leonie', 'f');
INSERT INTO FIRSTNAME VALUES (10,  'Laura', 'f');
INSERT INTO FIRSTNAME VALUES (11,  'Valentina', 'f');
INSERT INTO FIRSTNAME VALUES (12,  'Sophia', 'f');
INSERT INTO FIRSTNAME VALUES (13,  'Lea', 'f');
INSERT INTO FIRSTNAME VALUES (14,  'Mia', 'f');
INSERT INTO FIRSTNAME VALUES (15,  'Johanna', 'f');
INSERT INTO FIRSTNAME VALUES (16,  'Katharina', 'f');
INSERT INTO FIRSTNAME VALUES (17,  'Lara', 'f');
INSERT INTO FIRSTNAME VALUES (18,  'Emilia', 'f');
INSERT INTO FIRSTNAME VALUES (19,  'Amelie', 'f');
INSERT INTO FIRSTNAME VALUES (20,  'Magdalena', 'f');
INSERT INTO FIRSTNAME VALUES (21,  'Lisa', 'f');
INSERT INTO FIRSTNAME VALUES (22,  'Luisa', 'f');
INSERT INTO FIRSTNAME VALUES (23,  'Jana', 'f');
INSERT INTO FIRSTNAME VALUES (24,  'Clara', 'f');
INSERT INTO FIRSTNAME VALUES (25,  'Viktoria', 'f');
INSERT INTO FIRSTNAME VALUES (26,  'Nina', 'f');
INSERT INTO FIRSTNAME VALUES (27,  'Theresa', 'f');
INSERT INTO FIRSTNAME VALUES (28,  'Elena', 'f');
INSERT INTO FIRSTNAME VALUES (29,  'Emily', 'f');
INSERT INTO FIRSTNAME VALUES (30,  'Isabella', 'f');
INSERT INTO FIRSTNAME VALUES (31,  'Alina', 'f');
INSERT INTO FIRSTNAME VALUES (32,  'Marlene', 'f');
INSERT INTO FIRSTNAME VALUES (33,  'Lina', 'f');
INSERT INTO FIRSTNAME VALUES (34,  'Helena', 'f');
INSERT INTO FIRSTNAME VALUES (35,  'Selina', 'f');
INSERT INTO FIRSTNAME VALUES (36,  'Lilly', 'f');
INSERT INTO FIRSTNAME VALUES (37,  'Annika', 'f');
INSERT INTO FIRSTNAME VALUES (38,  'Miriam', 'f');
INSERT INTO FIRSTNAME VALUES (39,  'Pia', 'f');
INSERT INTO FIRSTNAME VALUES (40,  'Vanessa', 'f');
INSERT INTO FIRSTNAME VALUES (41,  'Nora', 'f');
INSERT INTO FIRSTNAME VALUES (42,  'Elisa', 'f');
INSERT INTO FIRSTNAME VALUES (43,  'Eva', 'f');
INSERT INTO FIRSTNAME VALUES (44,  'Emely', 'f');
INSERT INTO FIRSTNAME VALUES (45,  'Anna-Lena', 'f');
INSERT INTO FIRSTNAME VALUES (46,  'Franziska', 'f');
INSERT INTO FIRSTNAME VALUES (47,  'Maja', 'f');
INSERT INTO FIRSTNAME VALUES (48,  'Paula', 'f');
INSERT INTO FIRSTNAME VALUES (49,  'Larissa', 'f');
INSERT INTO FIRSTNAME VALUES (50,  'Valerie', 'f');
INSERT INTO FIRSTNAME VALUES (51,  'Ella', 'f');
INSERT INTO FIRSTNAME VALUES (52,  'Jasmin', 'f');
INSERT INTO FIRSTNAME VALUES (53,  'Elisabeth', 'f');
INSERT INTO FIRSTNAME VALUES (54,  'Anja', 'f');
INSERT INTO FIRSTNAME VALUES (55,  'Antonia', 'f');
INSERT INTO FIRSTNAME VALUES (56,  'Maria', 'f');
INSERT INTO FIRSTNAME VALUES (57,  'Fabienne', 'f');
INSERT INTO FIRSTNAME VALUES (58,  'Isabel', 'f');
INSERT INTO FIRSTNAME VALUES (59,  'Livia', 'f');
INSERT INTO FIRSTNAME VALUES (60,  'Christina', 'f');
INSERT INTO FIRSTNAME VALUES (61,  'Lukas', 'm');
INSERT INTO FIRSTNAME VALUES (62,  'Tobias', 'm');
INSERT INTO FIRSTNAME VALUES (63,  'Maximilian', 'm');
INSERT INTO FIRSTNAME VALUES (64,  'Luca', 'm');
INSERT INTO FIRSTNAME VALUES (65,  'David', 'm');
INSERT INTO FIRSTNAME VALUES (66,  'Jakob', 'm');
INSERT INTO FIRSTNAME VALUES (67,  'Felix', 'm');
INSERT INTO FIRSTNAME VALUES (68,  'Elias', 'm');
INSERT INTO FIRSTNAME VALUES (69,  'Jonas', 'm');
INSERT INTO FIRSTNAME VALUES (70,  'Paul', 'm');
INSERT INTO FIRSTNAME VALUES (71,  'Alexander', 'm');
INSERT INTO FIRSTNAME VALUES (72,  'Raphael', 'm');
INSERT INTO FIRSTNAME VALUES (73,  'Sebastian', 'm');
INSERT INTO FIRSTNAME VALUES (74,  'Julian', 'm');
INSERT INTO FIRSTNAME VALUES (75,  'Simon', 'm');
INSERT INTO FIRSTNAME VALUES (76,  'Leon', 'm');
INSERT INTO FIRSTNAME VALUES (77,  'Fabian', 'm');
INSERT INTO FIRSTNAME VALUES (78,  'Florian', 'm');
INSERT INTO FIRSTNAME VALUES (79,  'Moritz', 'm');
INSERT INTO FIRSTNAME VALUES (80,  'Philipp', 'm');
INSERT INTO FIRSTNAME VALUES (81,  'Matthias', 'm');
INSERT INTO FIRSTNAME VALUES (82,  'Nico', 'm');
INSERT INTO FIRSTNAME VALUES (83,  'Noah', 'm');
INSERT INTO FIRSTNAME VALUES (84,  'Michael', 'm');
INSERT INTO FIRSTNAME VALUES (85,  'Samuel', 'm');
INSERT INTO FIRSTNAME VALUES (86,  'Benjamin', 'm');
INSERT INTO FIRSTNAME VALUES (87,  'Daniel', 'm');
INSERT INTO FIRSTNAME VALUES (88,  'Niklas', 'm');
INSERT INTO FIRSTNAME VALUES (89,  'Dominik', 'm');
INSERT INTO FIRSTNAME VALUES (90,  'Johannes', 'm');
INSERT INTO FIRSTNAME VALUES (91,  'Lorenz', 'm');
INSERT INTO FIRSTNAME VALUES (92,  'Marcel', 'm');
INSERT INTO FIRSTNAME VALUES (93,  'Leo', 'm');
INSERT INTO FIRSTNAME VALUES (94,  'Gabriel', 'm');
INSERT INTO FIRSTNAME VALUES (95,  'Valentin', 'm');
INSERT INTO FIRSTNAME VALUES (96,  'Matteo', 'm');
INSERT INTO FIRSTNAME VALUES (97,  'Jan', 'm');
INSERT INTO FIRSTNAME VALUES (98,  'Stefan', 'm');
INSERT INTO FIRSTNAME VALUES (99,  'Konstantin', 'm');
INSERT INTO FIRSTNAME VALUES (100, 'Manuel', 'm');
INSERT INTO FIRSTNAME VALUES (101, 'Luis', 'm');
INSERT INTO FIRSTNAME VALUES (102, 'Emil', 'm');
INSERT INTO FIRSTNAME VALUES (103, 'Marco', 'm');
INSERT INTO FIRSTNAME VALUES (104, 'Thomas', 'm');
INSERT INTO FIRSTNAME VALUES (105, 'Ben', 'm');
INSERT INTO FIRSTNAME VALUES (106, 'Clemens', 'm');
INSERT INTO FIRSTNAME VALUES (107, 'Fabio', 'm');
INSERT INTO FIRSTNAME VALUES (108, 'Kilian', 'm');
INSERT INTO FIRSTNAME VALUES (109, 'Andreas', 'm');
INSERT INTO FIRSTNAME VALUES (110, 'Christoph', 'm');
INSERT INTO FIRSTNAME VALUES (111, 'Tim', 'm');
INSERT INTO FIRSTNAME VALUES (112, 'Max', 'm');
INSERT INTO FIRSTNAME VALUES (113, 'Jonathan', 'm');
INSERT INTO FIRSTNAME VALUES (114, 'Martin', 'm');
INSERT INTO FIRSTNAME VALUES (115, 'Adrian', 'm');
INSERT INTO FIRSTNAME VALUES (116, 'Oliver', 'm');
INSERT INTO FIRSTNAME VALUES (117, 'Timo', 'm');
INSERT INTO FIRSTNAME VALUES (118, 'Laurenz', 'm');
INSERT INTO FIRSTNAME VALUES (119, 'Christian', 'm');
INSERT INTO FIRSTNAME VALUES (120, 'Anton', 'm');

COMMIT;



DROP TABLE CUSTOMER;

CREATE TABLE CUSTOMER
(
	CUSTOMER_ID INTEGER PRIMARY KEY,
	FIRST_NAME  CHAR(200),
    GENDER      CHAR(200),
	BALANCE     DECIMAL(10,2)
);

COMMIT;



DROP SEQUENCE SEQ_CUSTOMER_ID;

CREATE SEQUENCE SEQ_CUSTOMER_ID START WITH 1;

COMMIT;



INSERT INTO CUSTOMER
SELECT SEQ_CUSTOMER_ID.NEXTVAL,
       nam.FIRST_NAME,
       nam.GENDER,
       CAST((DBMS_RANDOM.VALUE*2000-500) AS DECIMAL(10,2))
FROM   DUAL cus
       INNER JOIN
       FIRSTNAME nam
       ON CAST(DBMS_RANDOM.VALUE*120 AS INTEGER) = nam.FIRST_NAME_ID;

INSERT INTO CUSTOMER
SELECT SEQ_CUSTOMER_ID.NEXTVAL,
       nam.FIRST_NAME,
       nam.GENDER,
       CAST((DBMS_RANDOM.VALUE*2000-500) AS DECIMAL(10,2))
FROM   CUSTOMER cus
       INNER JOIN
       FIRSTNAME nam
       ON CAST(DBMS_RANDOM.VALUE*120 AS INTEGER) = nam.FIRST_NAME_ID;

COMMIT;



CREATE TABLE CUSTOMER_INDEX
(
	CUSTOMER_ID INTEGER PRIMARY KEY,
	FIRST_NAME  CHAR(200),
    GENDER      CHAR(200),
	BALANCE     DECIMAL(10,2)
);

CREATE INDEX IDX_FIRST_NAME ON CUSTOMER_INDEX (FIRST_NAME);

CREATE BITMAP INDEX IDX_GENDER ON CUSTOMER_INDEX (GENDER);

INSERT INTO CUSTOMER_INDEX
SELECT *
FROM   CUSTOMER;
													
COMMIT;


													
CREATE TABLE CUSTOMER_NOINDEX
(
	CUSTOMER_ID INTEGER PRIMARY KEY,
	FIRST_NAME  CHAR(200),
    GENDER      CHAR(200),
	BALANCE     DECIMAL(10,2)
);

INSERT INTO CUSTOMER_NOINDEX
SELECT *
FROM   CUSTOMER;

COMMIT;



ALTER SYSTEM FLUSH BUFFER_CACHE;

SELECT count(*)
FROM   CUSTOMER_NOINDEX
WHERE  FIRST_NAME = 'Thomas';



ALTER SYSTEM FLUSH BUFFER_CACHE;

SELECT count(*)
FROM   CUSTOMER_INDEX
WHERE  FIRST_NAME = 'Thomas';



ALTER SYSTEM FLUSH BUFFER_CACHE;

SELECT count(*)
FROM   CUSTOMER_NOINDEX
WHERE  GENDER = 'm';



ALTER SYSTEM FLUSH BUFFER_CACHE;


SELECT count(*)
FROM   CUSTOMER_INDEX
WHERE  GENDER = 'm';



/*************************************************/
/**                 system USER !!!              */
/*************************************************/

DROP TABLESPACE TBS_GRIESMAYER_INDEX INCLUDING CONTENTS AND DATAFILES;
DROP USER GRIESMAYER CASCADE;
